/* nobsclean.do -- FDSZ/ RDSC Harald Stahl 2019.05.31 

Purpose: This do-file erases text between the nobsreg, end(textmark) command
         and the textmark, e.g. between ". nobsreg, end($$)" and "$$".       
		 Works also for nobsdes and end(textmark)                            */


/* Please, provide the path and the name of the log-file to be cleaned */

file open nobsfile using nobsreg.log, read text

/* Please, provide the path and the name of the cleaned log-file */

file open cleanfile using cleanfile.txt, write text replace

/* Please, specify the textmark */

local endmark "$$"

* -------------------------------- no change -------------------------------- *

local flag  = 0
local flage = 0
file read nobsfile line
while r(eof)==0 {
	if strpos(`"`line'"',"global endmark") > 0 {
		local flage = 1
	}
	if strpos(`"`line'"',". nobs") > 0 & (strpos(`"`line'"',"end(") > 0 | `flage'==1) {
		local flag = 1
	}
	if `"`macval(line)'"' == "`endmark'" {
		local flag = 0
	}
	if `flag'==0 {
		file write cleanfile `"  `macval(line)'"' _n 
	}
	file read  nobsfile line
}
file close cleanfile
file close nobsfile
